char *GetMsg(int MsgId)
{
  return(ExtSearchInfo.GetMsg(ExtSearchInfo.ModuleNumber,MsgId));
}


void InitDialogItems(struct InitDialogItem *Init,struct FarDialogItem *Item,
                    int ItemsNumber )
{
InitDialogItems( Init, Item, ItemsNumber, -1, -1 );
}

void InitDialogItems(struct InitDialogItem *Init,struct FarDialogItem *Item,
                    int ItemsNumber, int UpSetRegExp, int Type )
{
  int J;
  for (int I=0;I<ItemsNumber;I++)
  {
    if( UpSetRegExp > 0 ){
       switch( Type ){
          case ReplaceTypeDialog:{
             switch( I ){
                case NRI_CaseSensitive:
                case NRI_ReverseSearch:
                case NRI_WordSearch:
                   J = I + CHECKBOX_MOVE_DN; //  
                break;
                case NRI_SetRegExp:
                   J = I - CHECKBOX_MOVE_UP; //  
                break;
                default: J = I;
             }
          }break;  

          case SearchTypeDialog:{
             switch( I ){
                case NDI_CaseSensitive:
                case NDI_ReverseSearch:
                case NDI_WordSearch:
                   J = I + CHECKBOX_MOVE_DN; //  
                break;
                case NDI_SetRegExp:
                   J = I - CHECKBOX_MOVE_UP; //  
                break;
                default: J = I;
             }
          }break;

          case SearchInFileTypeDialog:{
             switch( I ){
                case NFI_CaseSensitive:
                case NFI_WordSearch:
                   J = I + CHECKBOX_MOVE_DN; //  
                break;
                case NFI_SetRegExp:
                   J = I - CHECKBOX_MOVE_UP + 1; //  
                break;
                default: J = I;
             }
          }break;

          case ReplaceInFileTypeDialog:{
             switch( I ){
                case NRFI_CaseSensitive:
                case NRFI_WordSearch:
                   J = I + CHECKBOX_MOVE_DN; //  
                break;
                case NRFI_SetRegExp:
                   J = I - CHECKBOX_MOVE_UP + 1; //  
                break;
                default: J = I;
             }
          }break;

       }  
    }
    else J = I;

    Item[J].Type=Init[I].Type;

    if( UpSetRegExp ){//६頥 
       Item[J].X1=Init[J].X1;
       Item[J].Y1=Init[J].Y1;
       Item[J].X2=Init[J].X2;
       Item[J].Y2=Init[J].Y2;
    }
    else{
       Item[J].X1=Init[I].X1;
       Item[J].Y1=Init[I].Y1;
       Item[J].X2=Init[I].X2;
       Item[J].Y2=Init[I].Y2;
    }

    Item[J].Focus=Init[I].Focus;
    Item[J].Selected=Init[I].Selected;
    Item[J].Flags=Init[I].Flags;
    Item[J].DefaultButton=Init[I].DefaultButton;
    if ((unsigned int)Init[I].Data<2000)
      strcpy(Item[J].Data,GetMsg((unsigned int)Init[I].Data));
    else
      strcpy(Item[J].Data,Init[I].Data);
  }
}

//। ᨬ    (⭮  ⭮ ᫮ ᨬ '\' ।  )
static int ThisSymbol( char *beg, char *cur ){
   int num = 0;
   while( --cur > beg ){
      if( *cur == '\\' ) num++;
      else break;
   }
   if( num%2 )
      return 1;//⭮ - ᨬ
   else       
      return 0;//⭮ - 
}

LISTSEL *GetListSel( int ID, LISTSEL **lastsel, LISTSEL *cursel ){

   if( cursel && cursel->ID != ID ){
      if( !*lastsel ) *lastsel = cursel;

      LISTSEL *cur = *lastsel;

      if( cur )
         do{
            if( cur->ID == ID )
               return cur;
            cur = cur->prev;
         }while( cur );

      return NULL;   
   }
   return cursel;
}

LISTSEL *AddToListSel( int ID, LISTSEL **lastsel ){
   LISTSEL *newelem = new LISTSEL;

   memset( newelem, 0, sizeof(LISTSEL) );
   newelem->ID = ID;
   //ExtTestMessage( "ID", ID );
   //newelem->ProcSaveSelectForRestore = 0;
   //newelem->ProcResetSelect = 0; 

   if( *lastsel ){
      newelem->prev = *lastsel;
      (*lastsel)->post = newelem;
   }
   else
      newelem->prev = NULL;

   newelem->post = NULL;
   *lastsel = newelem;
   return newelem;
}


void InitListSel( int ID, LISTSEL **lastsel, LISTSEL **cursel ){
   *cursel = GetListSel( ID, lastsel, *cursel );
   if( !*cursel ){
      *cursel = AddToListSel( ID, lastsel );
      //if( *cursel ) ExtTestMessage("Done AddToListSel");
   }
}

void DelFromListSel( int ID, LISTSEL **last, LISTSEL **cur ){
   LISTSEL *item = *last;
   if( item )
      do{
         if( item->ID == ID ){
            // ᫥,   ⢥
            if( !item->post && item->prev ){
               *last = item->prev; 
               (*last)->post = NULL;

            }
            // ⢥ 
            else if( !item->post && !item->prev )
               *last = NULL;            
            // ,   ⢥ 
            else if( item->post && !item->prev ){
               item->post->prev = NULL;
            }
            //   ।
            else{
               item->post->prev = item->prev;
               item->prev->post = item->post;
            }
            *cur  = NULL;
            delete item;
            break;
         }
         item = item->prev;
      }while( item );
}

void DelAllItemsListSel( LISTSEL **last, LISTSEL **cursel ){
   LISTSEL *cur, *next;
   cur = *last;
   if( cur )
      do{
         next = cur->prev;
         delete cur;
         cur = next;
      }while( next );

   *cursel = NULL;
   *last   = NULL;
}

int GetProcSaveSelectForRestore( int ID, LISTSEL **lastsel, LISTSEL **cursel ){
   if( *cursel ){
      if( ID == (*cursel)->ID )
         return (*cursel)->ProcSaveSelectForRestore;
      else{
         if( (*cursel = GetListSel( ID, lastsel, *cursel )) != NULL )         
            return (*cursel)->ProcSaveSelectForRestore;
         else{
            *cursel = AddToListSel( ID, lastsel );
            return (*cursel)->ProcSaveSelectForRestore;
         }
      }
   }
   else
      return 0;
}

int GetProcResetSelect( int ID, LISTSEL **lastsel, LISTSEL **cursel ){
   if( *cursel ){
      if( ID == (*cursel)->ID )
         return (*cursel)->ProcResetSelect;
      else{
         if( (*cursel = GetListSel( ID, lastsel, *cursel )) != NULL )
            return (*cursel)->ProcResetSelect;
         else{
            *cursel = AddToListSel( ID, lastsel );
            return (*cursel)->ProcResetSelect;
         }
      }
   }
   else
      return 0;
}

bool CheckForEsc( void )
{
  int ExitCode=false;
  while (1)
  {
    INPUT_RECORD rec;
    static HANDLE hConInp=GetStdHandle(STD_INPUT_HANDLE);
    DWORD ReadCount;
    PeekConsoleInput(hConInp,&rec,1,&ReadCount);
    if (ReadCount==0)
      break;
    ReadConsoleInput(hConInp,&rec,1,&ReadCount);
    if (rec.EventType==KEY_EVENT)
      if (rec.Event.KeyEvent.wVirtualKeyCode==VK_ESCAPE)
        ExitCode=true;
  }
  return(ExitCode);
}

void ExtTestMessage( char *MessStr ){
 char *MsgItems[]={"TestMessage",MessStr,GetMsg(MOk)};
 ExtSearchInfo.Message(ExtSearchInfo.ModuleNumber,FMSG_WARNING,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),1);
}

void ExtTestMessage( char *MessStr, int Num ){
 char StrNum[20];
 char *MsgItems[]={"TestMessage",itoa( Num, StrNum, 10),MessStr,GetMsg(MOk)};
 ExtSearchInfo.Message(ExtSearchInfo.ModuleNumber,FMSG_WARNING,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),1);
}

void ExtTestMessage( char *MessStr, int Num, int NumButtons ){
 char StrNum[20];
 char *MsgItems[]={"TestMessage",itoa( Num, StrNum, 10),MessStr};
 ExtSearchInfo.Message(ExtSearchInfo.ModuleNumber,FMSG_WARNING,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),NumButtons);
}

